﻿using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Diagram.Controls;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Visio_2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            PropertyEditor property = new PropertyEditor();
            property.Dock = DockStyle.Right;
            property.Diagram = this.diagram1;
            this.Controls.Add(property);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SymbolPalette paletteToReturn = null;
            string strFileName = @"...\\...\\SOACP_Visio_Stencil.vss";
            //Create an instance of VisioStencilConverter
            VisioStencilConverter converter = new VisioStencilConverter(strFileName);
            converter.ShowProgressDialog = true;
            //Convert the stencil as SymbolPalette
            paletteToReturn = converter.Convert();

            ///Hide the connection point by default
            foreach (Node node in paletteToReturn.Nodes)
            {
                foreach (ConnectionPoint cp in node.Ports)
                {
                    if (!(cp is CentralPort))
                    {
                        cp.Visible = false;
                    }
                }
            }

            paletteGroupBar1.AddPalette(paletteToReturn);

            diagram1.MouseMove += diagram1_MouseMove;
        }
        Node nodeHit = null;
        void diagram1_MouseMove(object sender, MouseEventArgs e)
        {
            if (diagram1.Controller.ActiveTool is HandleMoveTool && diagram1.Controller.ActiveTool.InAction)
            {
                Node tempHit = diagram1.Controller.GetNodeAtPoint(this.diagram1.Controller.MouseLocation);
                if (tempHit != null)
                {
                    nodeHit = tempHit;
                    foreach (ConnectionPoint cp in nodeHit.Ports)
                    {
                        if (!(cp is CentralPort))
                        {
                            cp.Visible = true;
                        }
                    }
                }
                if (tempHit == null && nodeHit != null)
                {
                    foreach (ConnectionPoint cp in nodeHit.Ports)
                    {
                        if (!(cp is CentralPort))
                        {
                            cp.Visible = false;
                        }
                    }
                    nodeHit = null;
                }
            }
            
        }
    }
}
